//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Patient, PatientDocument } from '../Patient';
import { PatientService } from '../PatientService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Patient')
@UseBefore(checkApiDisabled(PatientBaseController))
export class PatientBaseController extends BaseController {
    protected model: Model<PatientDocument>;

    protected static readonly _objName: string = 'Patient';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.PATIENT.READ,
        create: MEDICALPRACTICE_PERMISSIONS.PATIENT.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.PATIENT.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.PATIENT.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(patientService: PatientService) {
        super(Patient, patientService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(PatientBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async getAllPatient(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(PatientBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async getOnePatient(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(PatientBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async postPatient(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(PatientBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async patchPatient(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(PatientBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async deletePatient(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsPatient(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(PatientBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async getCsvExportPatient(@Res() response, @QueryParams() query) {
        response.attachment(`${PatientBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(PatientBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async getXlsxExportPatient(@Res() response, @QueryParams() query) {
        response.attachment(`${PatientBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(PatientBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.PATIENT.READ))
    @UseBefore(authenticated)
    public async getPdfExportPatient(@Res() response, @QueryParams() query) {
        response.attachment(`${PatientBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
